function[FOut, rho, ux, uy] = lattboltz(FIn, tau) % Lattice Boltzmann

[m,n,~] = size(FIn);
c = [[0,0] ; [0,1] ; [-1,0] ; [0,-1]; [1,0]; [-1,1]; [-1,-1]; [1,-1]; [1,1]];
t = [4/9 1/9 1/9 1/9 1/9 1/36 1/36  1/36 1/36];

FOut = zeros(m,n,9); rho = zeros(m,n);
ux = zeros(m,n); uy = zeros(m,n); fEq = zeros(m,n,9);

for i = 1 : 9 % Calculer les densités
    rho = rho + FIn(:,:,i);
end

for i = 1 : 9 % Calculer les vitesses
    for j = 1 : m
        for k = 1 : n
            ux(j,k) = ux(j,k) + (c(i,2)*FIn(j,k,i))/(rho(j,k));
            uy(j,k) = uy(j,k) + (c(i,1)*FIn(j,k,i))/(rho(j,k));
        end
    end
end

u = zeros(2,m,n); u(1,:,:) = uy; u(2,:,:) = ux;

for j = 1 : m
    for k = 1 : n % Calculer les fEq  
        u2 = ux(j,k)*ux(j,k)+uy(j,k)*uy(j,k);
        for i = 1 : 9
            uc = ux(j,k)*c(i,2)+uy(j,k)*c(i,1);
            fEq(j,k,i) = rho(j,k)*t(i)*(1 + uc*3 + uc^2*4.5 - u2*1.5);
        end
    end
end

rhoEq = zeros(m,n);
uxEq = zeros(m,n); uyEq = zeros(m,n);

for i = 1 : 9 % Calculer les densités
    rhoEq = rhoEq + fEq(:,:,i);
end

for i = 1 : 9 % Calculer les vitesses
    for j = 1 : m
        for k = 1 : n
            uxEq(j,k) = uxEq(j,k) + (c(i,2)*fEq(j,k,i))/(rhoEq(j,k));
            uyEq(j,k) = uyEq(j,k) + (c(i,1)*fEq(j,k,i))/(rhoEq(j,k));
        end
    end
end

rhoDiff=max(max(rho-rhoEq))
uxDiff=max(max(rho.*ux-rhoEq.*uxEq))
uyDiff=max(max(rho.*uy-rhoEq.*uyEq))

for i = 1 : 9 % Calculer tous les f_i out
    FOut(:,:,i) = (1 - 1/tau)*FIn(:,:,i) + (1/tau)*fEq(:,:,i);
    FOut(:,:,i) = circshift(FOut(:,:,i), c(i,:));
end